package com.huimv.guowei.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnergyWaterPressure;
import com.huimv.guowei.admin.entity.EnvDeviceChip;
import com.huimv.guowei.admin.entity.vo.WaterLinePressureVo;
import com.huimv.guowei.admin.entity.vo.WaterLineVo;
import com.huimv.guowei.admin.mapper.EnergyWaterMapper;
import com.huimv.guowei.admin.mapper.EnergyWaterPressureMapper;
import com.huimv.guowei.admin.mapper.EnvDeviceChipMapper;
import com.huimv.guowei.admin.service.IEnergyWaterPressureService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-21
 */
@Service
public class EnergyWaterPressureServiceImpl extends ServiceImpl<EnergyWaterPressureMapper, EnergyWaterPressure> implements IEnergyWaterPressureService {

    @Resource
    private EnergyWaterPressureMapper energyWaterPressureMapper;
    @Resource
    private EnvDeviceChipMapper envDeviceChipMapper;

    @Override
    public Result getWaterPressure(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");

        List<EnvDeviceChip> deviceChipList = envDeviceChipMapper.selectList(new QueryWrapper<EnvDeviceChip>().eq("chip_type", 3));
        List<String> chipCodeList = new ArrayList<>();
        for (EnvDeviceChip envDeviceChip : deviceChipList) {
            chipCodeList.add(envDeviceChip.getChipCode());
        }
        String chipCodes = String.join(",", chipCodeList);
        WaterLinePressureVo waterLinePressureVo = new WaterLinePressureVo();
        chipCodes = "("+chipCodes+")";
        waterLinePressureVo = energyWaterPressureMapper.getWaterPressure(farmId,chipCodeList,chipCodes);
        return new Result(ResultCode.SUCCESS,waterLinePressureVo);
    }
}
